clear all;
clc;
tic

load('uvinitial.mat')
a_urn=5;
b_urn=3;
te=8000-(a_urn+1)*b_urn;
xl=0;xr=5;yb=0;yt=5;tb=0;M=25;N=25;
dx=xr/M;
dy=yt/N;
Du=0.00016;Dv=0.00008;
dt=(9/40)*dx^2/max(Du,Dv);
F=0.035; k=0.065;
m=M+1;n=N+1;
mn=m*n;mn2=2*mn;
x=linspace(xl,xr,m);y=linspace(yb,yt,n);
tt=1;
for t=0:dt:te
T=[reshape(u,mn,1);reshape(v,mn,1)];
uold=u;vold=v;
for it=1:2
DF1=zeros(mn2,mn2);DF3=zeros(mn2,mn2);
b=zeros(mn2,1);
for i=2:m-1
for j=2:n-1
DF1(i+(j-1)*m,i-1+(j-1)*m)=-Du/dx^2;
DF1(i+(j-1)*m,i+(j-1)*m)= Du*(2/dx^2+2/dy^2)-F+1/(1*dt);
DF1(i+(j-1)*m,i+1+(j-1)*m)=-Du/dx^2;
DF1(i+(j-1)*m,i+(j-2)*m)=-Du/dy^2;
DF1(i+(j-1)*m,i+j*m)=-Du/dy^2;
b(i+(j-1)*m)=-uold(i,j)/(1*dt)-F;
DF1(mn+i+(j-1)*m,mn+i-1+(j-1)*m)=-Dv/dx^2;
DF1(mn+i+(j-1)*m,mn+i+(j-1)*m)= Dv*(2/dx^2+2/dy^2)+1/(1*dt);
DF1(mn+i+(j-1)*m,mn+i+1+(j-1)*m)=-Dv/dx^2;
DF1(mn+i+(j-1)*m,mn+i+(j-2)*m)=-Dv/dy^2;
DF1(mn+i+(j-1)*m,mn+i+j*m)=-Dv/dy^2;
DF1(mn+i+(j-1)*m,i+(j-1)*m)=(F+k);
DF3(i+(j-1)*m,i+(j-1)*m)=2*u(i,j)*v(i,j);
DF3(i+(j-1)*m,mn+i+(j-1)*m)=u(i,j)^2;
DF3(mn+i+(j-1)*m,i+(j-1)*m)=-2*u(i,j)*v(i,j);
DF3(mn+i+(j-1)*m,mn+i+(j-1)*m)=-u(i,j)^2;
b(mn+i+(j-1)*m)=-vold(i,j)/(1*dt);
end
end
for i=1:m % bottom and top Neumann conditions
j=1;DF1(i+(j-1)*m,i+(j-1)*m)=3;
DF1(i+(j-1)*m,i+j*m)=-4;
DF1(i+(j-1)*m,i+(j+1)*m)=1;
j=n;DF1(i+(j-1)*m,i+(j-1)*m)=3;
DF1(i+(j-1)*m,i+(j-2)*m)=-4;
DF1(i+(j-1)*m,i+(j-3)*m)=1;
j=1;DF1(mn+i+(j-1)*m,mn+i+(j-1)*m)=3;
DF1(mn+i+(j-1)*m,mn+i+j*m)=-4;
DF1(mn+i+(j-1)*m,mn+i+(j+1)*m)=1;
j=n;DF1(mn+i+(j-1)*m,mn+i+(j-1)*m)=3;
DF1(mn+i+(j-1)*m,mn+i+(j-2)*m)=-4;
DF1(mn+i+(j-1)*m,mn+i+(j-3)*m)=1;
end
for j=2:n-1 %left and right Neumann conditions
i=1;DF1(i+(j-1)*m,i+(j-1)*m)=3;
DF1(i+(j-1)*m,i+1+(j-1)*m)=-4;
DF1(i+(j-1)*m,i+2+(j-1)*m)=1;
i=m;DF1(i+(j-1)*m,i+(j-1)*m)=3;
DF1(i+(j-1)*m,i-1+(j-1)*m)=-4;
DF1(i+(j-1)*m,i-2+(j-1)*m)=1;
i=1;DF1(mn+i+(j-1)*m,mn+i+(j-1)*m)=3;
DF1(mn+i+(j-1)*m,mn+i+1+(j-1)*m)=-4;
DF1(mn+i+(j-1)*m,mn+i+2+(j-1)*m)=1;
i=m;DF1(mn+i+(j-1)*m,mn+i+(j-1)*m)=3;
DF1(mn+i+(j-1)*m,mn+i-1+(j-1)*m)=-4;
DF1(mn+i+(j-1)*m,mn+i-2+(j-1)*m)=1;
end
DF=DF1+DF3;
W=(DF1+DF3/3)*T+b;
T=T-DF\W;
u=reshape(T(1:mn),m,n);v=reshape(T(mn+1:mn2),m,n);
end

ut(tt)=sum(sum(u))/N^2;
vt(tt)=sum(sum(v))/N^2;
tx(tt)=t;
tt=tt+1;
end
figure(1)
contour(u',100);

figure(2)
contour(v',100);

% ---- question 4 ----
% concentration vs time calculations

figure(3)
plot(tx,ut,tx,vt)
legend('u','v')
xlabel('time (s)')
ylabel('average concentration')

toc
